VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsAgent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*****************************************************************************
'        
'  Project -> References
'   Microsoft Agent Control 2.0
'  (C:\windows\msagent\AgentCtl.dll)
'*****************************************************************************

Private WithEvents MyAgent As AgentObjects.Agent
Attribute MyAgent.VB_VarHelpID = -1
Private MyCharacter        As AgentObjects.IAgentCtlCharacterEx
Private MyRequest          As AgentObjects.IAgentCtlRequest
                                    '   WaitRequestComplete
Private WithEvents WaitingTimer As VB.Timer
Attribute WaitingTimer.VB_VarHelpID = -1
Private WaitingTimerForm        As New frmTimer

Private Const CHARACTER_ID As String = "MyCharacter"
Private Const TXT_EVENT    As String = "  "
Private Const PUSTO        As String = ""

Private Declare Function _
   a2ku_apigettime Lib "winmm.dll" _
   Alias "timeGetTime" () As Long   '  TimerStart  TimerStop
Private Ingstartingtime As Long     '  TimerStart  TimerStop
Private nMaxWaitingTime As Long     '   
                                    '.   
                                    'MaxWaitingTime   
                                    'WaitRequestComplete

Private aAnimationNames() As String '     .

Public Enum enumAnimTypes           '    StopAll (StopIt)
   anim_All = 0                     '  .
   animMoveTo                       '   MoveTo
   animPlay                         '   Play
   animSpeak                        '   Speak
End Enum
Public Enum enumLanguages           '   - LanguageID
   langArabic = &H401
   langBasque = &H42D
   langChineseSimple = &H804
   langChineseTradit = &H404
   langCroatian = &H41A
   langCzech = &H405
   langDanish = &H406
   langDutch = &H413
   langEngBrit = &H809
   langEngUS = &H409
   langFinnish = &H40B
   langFrench = &H40C
   langGerman = &H407
   langGreek = &H408
   langHebrew = &H40D
   langHungarian = &H40E
   langItalian = &H410
   langJapanese = &H411
   langKorean = &H412
   langNorwegian = &H414
   langPolish = &H415
   langPortugPortugal = &H816
   langPortugBrazil = &H416
   langRomanian = &H418
   langRussian = &H419
   langSlovakian = &H41B
   langSlovenian = &H424
   langSpanish = &HC0A
   langSwedish = &H41D
   langThai = &H41E
   langTurkish = &H41F
End Enum
   
Private CurrentLanguage As Long     '   (
                                    ' LanguageID)

'*****************************************************************************
' API Windows  ,     .
'  timeGetTime()       Windows.
'      ,    
'   .    WaitRequestComplete.
'*****************************************************************************
Private Sub TimerStart()                         ' .
    Ingstartingtime = a2ku_apigettime()
End Sub
Private Function TimerStop() As Long             ' 
    TimerStop = a2ku_apigettime() - Ingstartingtime '( 
                                                 '   ).
End Function

Private Sub Class_Initialize()
   nMaxWaitingTime = 15000
   Set WaitingTimer = WaitingTimerForm.AgentTimer
   With WaitingTimer
      .Interval = 500
      .Enabled = False
   End With
   hHook = SetWindowsHookEx( _
      WH_KEYBOARD, AddressOf KeyboardProc, _
      App.hInstance, App.ThreadID)               '   
End Sub

'*****************************************************************************
'                              
'*****************************************************************************

Private Sub MyAgent_ActivateInput(ByVal CharacterID As String)
'       Show , ,
'    - ,     (
'  )
End Sub

Private Sub MyAgent_ActiveClientChange(ByVal CharacterID As String, _
                                       ByVal Active As Boolean)
'      .  . , ,
'         .  
'  ,  MS Agent -  ,    - .
'             ,  
'      .
End Sub

Private Sub MyAgent_AgentPropertyChange()
'      .  ,    
'  ,     .
End Sub

Private Sub MyAgent_BalloonHide(ByVal CharacterID As String)
'      .
'  CharacterID   ,  -
'  .     CharacterID  
'   CHARACTER_ID, ..     
' .
End Sub

Private Sub MyAgent_BalloonShow(ByVal CharacterID As String)
'      .
'  CharacterID   BalloonHide
End Sub

Private Sub MyAgent_Bookmark(ByVal BookmarkID As Long)
'   \Mrk=number\    ,  
'   Speak        Think.
'         , -
'   Bookmark.
'  number   .   
'   Long,      :
' 0, 2147483647, 2147483646.
'        BookmarkID
'  Speak  Think      .

   Select Case BookmarkID
   Case 10
      Debug.Print "  10"
   End Select
End Sub

Private Sub MyAgent_Click(ByVal CharacterID As String, _
                          ByVal Button As Integer, _
                          ByVal Shift As Integer, _
                          ByVal X As Integer, ByVal Y As Integer)
'        . :
' CharacterID   BalloonHide
' Button -     
' Shift -      
' X, Y -      .
End Sub

Private Sub MyAgent_Command(ByVal UserInput As Object)
'      .
'  UserInput   Command,   :
'  CharacterID -   ( )
'  Name - ,  ID .
'  Confidence -  Long,    .
'  Voice - ,     .
'  Alt1Name - ,    ()  .
'  Alt1Confidence -  Long,    
'                    ()  .
'  Alt1Voice - ,      
'              .
'  Alt2... -   Alt1...    .
'  Count -  Long,    .
'
'     Commands.
'  :

   Select Case UserInput.Name                    '  .
   Case "WhatTime"
      MyCharacter.LanguageID = CurrentLanguage
      Speak " " & Hour(Now) & "  " & Minute(Now) & " "
   Case "ShowPropertySheet"
      ShowPropertySheet
   Case "ShowCommandsWindow"
      ShowCommandsWindow
   End Select
End Sub

Private Sub MyAgent_DblClick(ByVal CharacterID As String, _
                             ByVal Button As Integer, _
                             ByVal Shift As Integer, _
                             ByVal X As Integer, ByVal Y As Integer)
'        .
'    Click
End Sub

Private Sub MyAgent_DeactivateInput(ByVal CharacterID As String)
'       Hide , ,
'    - ,     (
'  )
End Sub

Private Sub MyAgent_DefaultCharacterChange(ByVal GUID As String)
'        -.
'    ,     - (.
'  Load ).
'  GUID    .
End Sub

Private Sub MyAgent_DragComplete(ByVal CharacterID As String, _
                                 ByVal Button As Integer, _
                                 ByVal Shift As Integer, _
                                 ByVal X As Integer, ByVal Y As Integer)
'  DragStart  DragComplete     
'  .       ,
'  DragStart.     - DragComplete.
'    Click
End Sub

Private Sub MyAgent_DragStart(ByVal CharacterID As String, _
                              ByVal Button As Integer, _
                              ByVal Shift As Integer, _
                              ByVal X As Integer, ByVal Y As Integer)
' .    DragComplete
End Sub

Private Sub MyAgent_HelpComplete(ByVal CharacterID As String, _
                                 ByVal Name As String, ByVal Cause As Integer)
   '     .  
   Debug.Print TXT_EVENT & "HelpComplete"
End Sub

Private Sub MyAgent_Hide(ByVal CharacterID As String, ByVal Cause As Integer)
'     . :
' CharacterID   BalloonHide
' Cause -  , ,   
'           :
'  1 -           
'        ;
'  3 -    ;
'  5 -      ;
'  7 -        .
End Sub

Private Sub MyAgent_ListenStart(ByVal CharacterID As String)
'       Listen(True)
'  (   )
End Sub

Private Sub MyAgent_ListenComplete(ByVal CharacterID As String, _
                                   ByVal Cause As Integer)
'        .
   MyCharacter.LanguageID = CurrentLanguage      '   
                                                 '  
                                                 '  .
End Sub

Private Sub MyAgent_Move(ByVal CharacterID As String, _
                         ByVal X As Integer, ByVal Y As Integer, _
                         ByVal Cause As Integer)
'     . :
'  CharacterID -  
'  X  Y -      
'  Cause - ,    :
'     1 -    
'     2 -   
'     3 -    
'     4 - Agent Server      .
End Sub

Private Sub MyAgent_RequestComplete(ByVal Request As Object)
'  ,   GestureAt, Get, Hide, Interrupt, Load,
' MoveTo, Play, Show, Speak, WaitGet  Character  .
' (Request.Status = 0)
End Sub

Private Sub MyAgent_RequestStart(ByVal Request As Object)
'  ,   GestureAt, Get, Hide, Interrupt, Load,
' MoveTo, Play, Show, Speak, WaitGet  Character  .
' (Request.Status > 0)
End Sub

Private Sub MyAgent_Restart()
   '     .  
   Debug.Print TXT_EVENT & "Restart"
End Sub

Private Sub MyAgent_Show(ByVal CharacterID As String, ByVal Cause As Integer)
'     . :
'  CharacterID -  
'  Cause -      :
'     2 -         
'          .
'     4 -   
'     6 -    .

End Sub

Private Sub MyAgent_Shutdown()
   '     .  
   Debug.Print TXT_EVENT & "Shutdown"
End Sub

Private Sub MyAgent_Size(ByVal CharacterID As String, _
                         ByVal Width As Integer, ByVal Height As Integer)
'      . :
'  CharacterID -  
'  Width -     
'  Height -     .
End Sub

'*****************************************************************************
'                      
'                       
'*****************************************************************************

Public Sub Load(Optional ByVal CharacterID As String = PUSTO)
      
   Dim i&
   Dim var
      
   Set MyAgent = New AgentObjects.Agent          '  
   If CharacterID = PUSTO Then
      MyAgent.Characters.Load CHARACTER_ID       '   
                                                 '
   Else
      MyAgent.Characters.Load _
         CHARACTER_ID, CharacterID               '  ,
                                                 '    
                                                 '.
   End If
   Set MyCharacter = MyAgent.Characters(CHARACTER_ID)
   
   i = 0                                         '   -
   With MyCharacter                              ' .
      For Each var In .AnimationNames
         ReDim Preserve aAnimationNames(i)
         aAnimationNames(i) = var
         i = i + 1
      Next
   End With
   Set var = Nothing
End Sub

Public Function RequestStatus() As Integer
   RequestStatus = MyRequest.Status
End Function
Public Function RequestStatusString() As String  '  
   Select Case MyRequest.Status                  '  
   Case 0                                        '.
      RequestStatusString = "  "
   Case 1
      RequestStatusString = "   "
   Case 2
      RequestStatusString = " ."
   Case 3
      RequestStatusString = " "
   Case 4
      RequestStatusString = "   "
   Case Else
      RequestStatusString = "  "
   End Select
End Function

Private Sub WaitRequestComplete()                '  -
   WaitingTimer.Enabled = True                   ' 
End Sub
Private Sub WaitingTimer_Timer()
   TimerStart
   With MyRequest
      If .Status = 2 Or .Status = 4 Then
         If TimerStop < nMaxWaitingTime Then
            DoEvents
         Else                                    '  
            StopIt                               ' ,  -
         End If                                  ' .
      End If
   End With
End Sub

Public Sub ShowDefaultCharacterProperties( _
      Optional ByVal X& = 0, _
      Optional ByVal Y& = 0)
   
   If X = 0 Or Y = 0 Then                        '   -
      MyAgent.ShowDefaultCharacterProperties     '  .
   Else
      MyAgent.ShowDefaultCharacterProperties X, Y
   End If
End Sub

Public Function Activate( _
               Optional ByVal State) As Boolean  ' ,   
                                                 '. , 
   Activate = MyCharacter.Activate(State)        '  .
End Function

Public Function GestureAt( _
            ByVal X As Integer, Y As Integer) As AgentObjects.IAgentCtlRequest
   '        .
   'Agent Server    
   ' (, GestureLeft).    .
   
   Set MyRequest = Nothing
   Set MyRequest = MyCharacter.GestureAt(X, Y)
   Set GestureAt = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Function Show( _
   Optional ByVal Fast As Boolean = False) As AgentObjects.IAgentCtlRequest
                                                 ' .
   Set MyRequest = Nothing
   Set MyRequest = MyCharacter.Show(Fast)
   Set Show = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Sub ShowCommandsWindow()
'      " ", 
'     .
                                                 '  
                                                 '   
'  MyAgent.CommandsWindow.Visible = True         '  (English).
   Const RAVNO = " = "
   Dim sCmd As String
   Dim oCmd As AgentObjects.IAgentCtlCommandEx   ':
   For Each oCmd In MyCharacter.Commands         '1.    -
      With oCmd                                  '    ;
         If .Voice <> PUSTO Then sCmd = sCmd & .Caption & RAVNO & .Voice
      End With
   Next oCmd
   Set oCmd = Nothing
   Think sCmd                                    '2.    .
End Sub

Public Sub ShowPropertySheet()
'      "  ".
   With MyAgent.PropertySheet
                                                 ' :
                                                 '    - 
                                                 ' ( -
                                                 ').
      .Page = "Speech"                           ' - " "
      .Page = "Output"                           ' - ""
      '.Page = "Copyright"                       ' - " "
      .Visible = True                            '  .
   End With
End Sub

Public Function Play( _
            ByVal AnimationName As String) As AgentObjects.IAgentCtlRequest
   
   On Error Resume Next
   Set MyRequest = Nothing
                                                 '  .
   Set MyRequest = MyCharacter.Play(AnimationName)
   Set Play = MyRequest
   WaitRequestComplete                           '  .
   If Err Then
      Debug.Print "    " & AnimationName
      Debug.Print " " & Err
'      Debug.Assert (Err = 0)
      Exit Function
   End If
End Function

Public Function ShowPopupMenu(ByVal X As Integer, _
                              ByVal Y As Integer) As Boolean
                                                 '  
                                                 '   X,Y
   ShowPopupMenu = MyCharacter.ShowPopupMenu(X, Y)
End Function

Public Function Speak( _
   Optional ByVal TextToSpeak As String = PUSTO, _
   Optional ByVal Url As String = PUSTO) As AgentObjects.IAgentCtlRequest
'     TextToSpeak    Url  WAV  LWV
'      TextToSpeak     |,
'   : "||",      
'          .
'
'   ,  TextToSpeak   .   :
'  1.       "\"
'  2.     ,   : "\\"
'  3.        , 
'        :
'     Speak "\map="" ""=""  ""\"
'  4.    : "\pit\" = "\PIT\"
'  5.  ,        Speak.
'     ,   \Pit\      .
'     (,  -  -  ).
'  6. MS Agent    ,  Speech API,  ,
'             TTS.
'
'                                   
'   Chr
'    ,   .
'     : \Chr=string\
'    string:
'     Normal   -   ( )
'     Monotone -  
'     Whisper  - 
'  :
'     Speak "  . \Chr=""Whisper""\ ,  ."
'
'   Ctx
'       ,   e-mail.
'     : \Ctx=string\
'    string:
'     Unknow   -    ( )
'     Address  -     
'     E-mail   -   
'  :
'     Speak ": \Ctx=""Address""\ 654080, . , . "
'
'   Emp
'      .
'     : \Emp\
'  :
'     Speak " \Emp\  !"
'
'   Lst
'      (   ).
'   Speak        .
'  :
'     Speak "\Lst\"
'
'   Map
'    ,     .
'     : \Map=spokentext=ballontext\
'  :
'     Speak "\map="" ""=""  ""\"
'
'   Mrk
'     .      
'  MyAgent_Bookmark
'
'   Pau
'          .
'     : \Pau=number\
'  :
'     Speak "! \Pau=2000\   !"
'
'   Pit
'       .    
'  .  TTS      :)
'     : \Pit=number\
'  :
'     Speak "\Pit=50\    ,    !"
'
'   Rst
'       .   -  .
'  :
'     Speak "\Rst\"
'
'   Spd
'      (  ).
'     : \Spd=number\
'  :
'     Speak "\Pit=50\ \Spd=50\  \Emp\,  \Pau=1000\ \Emp\."
'
'   Vol
'       0  65535.
'     : \Vol=number\
'  :
'     Speak "\Vol=65000\  . \Vol=2000\   ."
  
  Dim bNoText As Boolean            '   TextToSpeak
  Dim bNoUrl  As Boolean            '   Url
  
  Set MyRequest = Nothing                        '  MyRequest.
  If TextToSpeak = PUSTO Then bNoText = True     ',  
  If Url = PUSTO Then bNoUrl = True              '.
   If bNoText And bNoUrl Then                    '     -
      Debug.Print " Speak  "   ',  .
      Debug.Assert False
      Exit Function
   ElseIf bNoText Then                           '   -
      Set MyRequest = MyCharacter.Speak(" ", Url)  ',   .
   ElseIf bNoUrl Then                            '   ,
      Set MyRequest = MyCharacter.Speak(TextToSpeak) '  .
   Else                                          '   ,
                                                 '  . 
                                                 ' ,   -
                                                 '   .
      Set MyRequest = MyCharacter.Speak(TextToSpeak, Url)
   End If
   Set Speak = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Sub StopIt(Optional ByVal OnlyCurrentAnimation As Boolean = False, _
                  Optional ByVal MethodType As enumAnimTypes = anim_All)
                                                 ' 
   If OnlyCurrentAnimation Then                  ' ;
      MyCharacter.Stop MyRequest
   Else
      Select Case MethodType
      Case enumAnimTypes.anim_All                '  ;
         MyCharacter.StopAll
      Case enumAnimTypes.animMoveTo              '  - .
         MyCharacter.StopAll "Move"
      Case enumAnimTypes.animPlay
         MyCharacter.StopAll "Play"
      Case enumAnimTypes.animSpeak
         MyCharacter.StopAll "Speak"
      End Select
   End If
End Sub

Public Function Think( _
   Optional ByVal TextToThink As String = PUSTO) _
                                              As AgentObjects.IAgentCtlRequest
'    TextToThink      ,   
'    Mrk (.  Bookmark)
   
   Set MyRequest = Nothing
   Set MyRequest = MyCharacter.Think(TextToThink)
   Set Think = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Function Listen(bListen As Boolean) As Boolean
'          .
   With MyCharacter
      If bListen Then                            '  , 
         .LanguageID = langEngUS                 '   
                                                 '(.  
                                                 ' MyAgent_ListenComplete).
      Else                                       '  , 
         .LanguageID = CurrentLanguage           '  .
      End If
      Listen = .Listen(bListen)
   End With
End Function

Public Function MoveTo( _
            ByVal X As Integer, _
            ByVal Y As Integer, _
   Optional ByVal Speed As Integer = 1000) As AgentObjects.IAgentCtlRequest
                                                 '   
   Set MyRequest = Nothing                       ' X,Y   Speed ().
   Set MyRequest = MyCharacter.MoveTo(X, Y, Speed)
   Set MoveTo = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Function Hide( _
   Optional ByVal Fast As Boolean = False) As AgentObjects.IAgentCtlRequest
   
   Set MyRequest = Nothing
   Set MyRequest = MyCharacter.Hide(Fast)        ' .
   Set Hide = MyRequest
   WaitRequestComplete                           '  .
End Function

Public Sub HideCommandsWindow()
'      " ", 
'     .
   MyAgent.CommandsWindow.Visible = False
End Sub

Public Sub HidePropertySheet()
'      "  ".
   MyAgent.PropertySheet.Visible = False
End Sub

Public Function Wait(WaitForReq As Object) As AgentObjects.IAgentCtlRequest
'   Wait   
'  ,    .  :
'  1.        ,
'     , James  Merlin.
'  2.   Wait:
'     James.Wait Merlin.Speak(" ?")
'     James.Speak ""
   
   Set Wait = MyCharacter.Wait(WaitForReq)
End Function

'*****************************************************************************
'                             
'                             
'*****************************************************************************

Public Property Get AnimationNames() As Variant  '   
   AnimationNames = aAnimationNames              ' .
End Property

Public Property Get AutoPopupMenu() As Boolean   '  -
   AutoPopupMenu = MyCharacter.AutoPopupMenu     '   
                                                 '  . .
End Property
Public Property Let AutoPopupMenu(ByVal bValue As Boolean)
   MyCharacter.AutoPopupMenu = bValue
End Property

Public Property Get Description() As String      '  -
   Description = MyCharacter.Description         ' ( ).
End Property

Public Property Get ExtraData() As String        ' 
   ExtraData = MyCharacter.ExtraData             ' .
End Property

Public Property Get GUID() As String             ' 
   GUID = MyCharacter.GUID                       '.
End Property

Public Property Get HasOtherClients() As Boolean '  
   HasOtherClients = MyCharacter.HasOtherClients ' .
End Property

Public Property Get Height() As Integer          '  
   Height = MyCharacter.Height                   ' .
End Property
Public Property Let Height(ByVal intValue As Integer)
   MyCharacter.Height = intValue
End Property

Public Property Get Width() As Integer           '  
   Width = MyCharacter.Width                     ' .
End Property
Public Property Let Width(ByVal intValue As Integer)
   MyCharacter.Width = intValue
End Property

Public Property Get LanguageID() As enumLanguages ' .
   LanguageID = MyCharacter.LanguageID
End Property
Public Property Let LanguageID(ByVal lonValue As enumLanguages)
   CurrentLanguage = lonValue
   MyCharacter.LanguageID = lonValue
End Property

Public Property Get Left() As Integer            '   
   Left = MyCharacter.Left                       '   . .
End Property
Public Property Let Left(ByVal intValue As Integer)
   MyCharacter.Left = intValue
End Property

Public Property Get Top() As Integer             '   
   Top = MyCharacter.Top                         '   . .
End Property
Public Property Let Top(ByVal intValue As Integer)
   MyCharacter.Top = intValue
End Property

Public Property Get MoveCause() As Integer
'    , ,    
'   :
'  0 -   
'  1 -    
'  2 -     
'  3 -    
'  4 - Agent Server     .
   MoveCause = MyCharacter.MoveCause
End Property

Public Property Get Name() As String             ' . -
   Name = MyCharacter.Name                       ' ,  
                                                 ' .
End Property
Public Property Let Name(ByVal strValue As String)
   MyCharacter.Name = strValue
End Property

Public Property Get OriginalHeight() As Integer  '  
   OriginalHeight = MyCharacter.OriginalHeight   '  .
End Property

Public Property Get OriginalWidth() As Integer   '  
   OriginalWidth = MyCharacter.OriginalWidth     '  .
End Property

Public Property Get SoundEffectsOn() As Boolean  '  -
   SoundEffectsOn = MyCharacter.SoundEffectsOn   '   -
                                                 ' .
End Property
Public Property Let SoundEffectsOn(ByVal bValue As Boolean)
   MyCharacter.SoundEffectsOn = bValue
End Property

Public Property Get Speed() As Long              '   (-
   Speed = MyCharacter.Speed                     ' ).  -
                                                 '   <Spd>
End Property

Public Property Get SRModeID() As String         '  -
   SRModeID = MyCharacter.SRModeID               ' .
End Property
Public Property Let SRModeID(ByVal strValue As String)
   MyCharacter.SRModeID = strValue
End Property

Public Property Get TTSModeID() As String        ' 
   TTSModeID = MyCharacter.TTSModeID             ' Text-to-Speech (TTS)
End Property
Public Property Let TTSModeID(ByVal strValue As String)
   MyCharacter.TTSModeID = strValue
End Property

Public Property Get Version() As String          '  (-
   Version = MyCharacter.Version                 ' )
End Property

Public Property Get VisibilityCause() As Integer
'   ,     :
'  0 -    
'  1 -   ,    
'             .
'  2 -   
'  3 -    
'  4 -    
'  5 -    
'  6 -    
'  7 -   ,    
   VisibilityCause = MyCharacter.VisibilityCause
End Property

Public Property Get Visible() As Boolean         '  -
   Visible = MyCharacter.Visible                 ' ( ).
End Property

Public Property Get MaxWaitingTime() As Long     '  
   MaxWaitingTime = nMaxWaitingTime              '  -
                                                 ' 
                                                 'WaitRequestComplete.
                                                 '  - 15 000 -
                                                 ' (Class_Initialize).
End Property
Public Property Let MaxWaitingTime(ByVal lonValue As Long)
   nMaxWaitingTime = lonValue
End Property

'*****************************************************************************
'                BALOON (  )
'*****************************************************************************

Public Property Get BackColor() As Long          '   
   BackColor = MyCharacter.Balloon.BackColor     ' ( ,
                                                 ' RGB, 16 . )
End Property

Public Property Get BorderColor() As Long        '  
   BorderColor = MyCharacter.Balloon.BorderColor '  (
                                                 ')
End Property

Public Property Get CharsPerLine() As Byte       '    -
   CharsPerLine = MyCharacter.Balloon.CharsPerLine '  
                                                 '(, ). 8-255.
End Property
Public Property Let CharsPerLine(nValue As Byte)
   If nValue < 8 Then nValue = 8
   With MyCharacter.Balloon
      .Style = (.Style And &HFF00FFFF) + (nValue * (2 ^ 16))
   End With
End Property

Public Property Get EnabledBaloon() As Boolean   '   
   Const BaloonOn As Long = 1                    '   
   With MyCharacter.Balloon                      '(, )
      EnabledBaloon = .Style And BaloonOn
   End With
End Property
Public Property Let EnabledBaloon(bValue As Boolean)
   Const BaloonOn As Long = 1
   With MyCharacter.Balloon
      If bValue Then
         .Style = .Style Or BaloonOn
      Else
         .Style = .Style And (Not BaloonOn)
      End If
   End With
End Property

Public Property Get FontBold() As Boolean
'       .  .  -
'            -
'     "  .
   FontBold = MyCharacter.Balloon.FontBold
End Property

Public Property Get FontItalic() As Boolean
'       .  .  -
'            -
'     "  .
   FontItalic = MyCharacter.Balloon.FontItalic
End Property

Public Property Get FontName() As String         '   
   FontName = MyCharacter.Balloon.FontName       '  .
End Property
Public Property Let FontName(ByVal strValue As String)
   MyCharacter.Balloon.FontName = strValue
End Property

Public Property Get FontSize() As Long           '   
   FontSize = MyCharacter.Balloon.FontSize       '  
                                                 '( 0  2160 ).
End Property
Public Property Let FontSize(ByVal lonValue As Long)
   MyCharacter.Balloon.FontSize = lonValue
End Property

Public Property Get FontStrikethru() As Boolean
'       .  . 
'           
'     "  .
   FontStrikethru = MyCharacter.Balloon.FontStrikethru
End Property

Public Property Get FontUnderline() As Boolean
'       .  . 
'           
'     "  .
   FontUnderline = MyCharacter.Balloon.FontUnderline
End Property

Public Property Get ForeColor() As Long          '   
   ForeColor = MyCharacter.Balloon.ForeColor     ' ( ,
                                                 ' RGB, 16 . )
End Property

Public Property Get NumberOfLines() As Byte      '    -
                                                 '  (,
                                                 ')
   NumberOfLines = MyCharacter.Balloon.NumberOfLines
End Property
Public Property Let NumberOfLines(ByVal nValue As Byte)
   If nValue = 0 Then nValue = 1
   With MyCharacter.Balloon
      .Style = (.Style And &HFFFFFF) + (nValue * (2 ^ 24))
   End With
End Property

Public Property Get FitToText() As Boolean       '  
   Const SizeToText As Long = 2                  '  (, )
   With MyCharacter.Balloon
      FitToText = .Style And SizeToText
   End With
End Property
Public Property Let FitToText(ByVal bValue As Boolean)
   Const SizeToText As Long = 2
   With MyCharacter.Balloon
      If bValue Then
         .Style = .Style Or SizeToText
      Else
         .Style = .Style And (Not SizeToText)
      End If
   End With
End Property

Public Property Get AutoHideBaloon() As Boolean  '  -
   Const AutoHide As Long = 4                    '   -
   With MyCharacter.Balloon                      '  .
      AutoHideBaloon = .Style And AutoHide       '(, ).
   End With
End Property
Public Property Let AutoHideBaloon(ByVal bValue As Boolean)
   Const AutoHide As Long = 4
   With MyCharacter.Balloon
      If bValue Then
         .Style = .Style Or AutoHide
      Else
         .Style = .Style And (Not AutoHide)
      End If
   End With
End Property

Public Property Get TypeToSpeech() As Boolean    '  
   Const Typing As Long = 8                      '(  ) 
   With MyCharacter.Balloon                      ' (, ).
      TypeToSpeech = .Style And Typing
   End With
End Property
Public Property Let TypeToSpeech(ByVal bValue As Boolean)
   Const Typing As Long = 8
   With MyCharacter.Balloon
      If bValue Then
         .Style = .Style Or Typing
      Else
         .Style = .Style And (Not Typing)
      End If
   End With
End Property

'*****************************************************************************
'                     ,  
'*****************************************************************************

Public Property Get Commands() As AgentObjects.IAgentCtlCommandsEx
'          
'  .
'                         COMMANDS
'   Add
'       .   -
'   Voice,       
'  (.     MyAgent_Command).
'  :
'  Name -  ( ) 
'  Caption - ,        
'                 " ".
'  Voice - ,      
'           (,       -
'            LanguageID -   ).
'  Enabled -  () 
'  Visible -      
'
'   Insert
'    Add,        
'  ,     .     
'  :
'  RefName -  ( )  
'  Before - :  (True)   (False)   
'             .
'
'   Remove
'  '     .
'
'   RemoveAll
'     .
'
'                         COMMANDS
'
'   Count
'      .
'
'   DefaultCommand
'        (  )
'
'   FontName
'        
'
'   FontSize
'        
'
'                             COMMAND
'       .Commands("Name")
'       Commands
'   Command    ( ).
'
'                          COMMAND
'   Caption
'          .
'
'   ConfidenceText
'          .
'
'   Enabled
'         .
'
'   Visible
'         .
'
'   Voice
'     ,   
'  . ,        
'   LanguageID -   .
   
   Set Commands = MyCharacter.Commands
End Property

Public Property Get AudioOutput() As AgentObjects.IAgentCtlAudioObjectEx
'   AudioOutput      
'  .
'                          AUDIOOUTPUT
'   Enabled
'     .  .
'
'   SoundEffects
'       . 
'  ,         "-
'    ." (.   
'  PropertySheet).
'
'   Status
'       ( ). :
'     0 -    ;
'     1 -     (  );
'     2 -  ,      ;
'     3 -  ,      ;
'     4 -  ,    ;
'     5 -   ,      ;
'     6 -     .
   
   Set AudioOutput = MyAgent.AudioOutput
End Property

Public Property Get SpeechInput() As AgentObjects.IAgentCtlSpeechInput
'   SpeechInput   ( )    ,
'        "
'   " (   ).

'                          SPEECHINPUT
'   Enabled
'     .  .
'
'   HotKey
'   ,      .
'
'   ListeningTip
'    ,    
'     .
   
   Set SpeechInput = MyAgent.SpeechInput
End Property

'*****************************************************************************
'                              
'*****************************************************************************
Private Sub Class_Terminate()                    '   .
   UnhookWindowsHookEx hHook                     '   
   Unload WaitingTimerForm
   Set WaitingTimer = Nothing
   Set WaitingTimerForm = Nothing
   Set MyCharacter = Nothing
   MyAgent.Characters.Unload CHARACTER_ID
   Set MyRequest = Nothing
   Set MyAgent = Nothing
   Debug.Print "MS Agent "
End Sub

