Attribute VB_Name = "modAgentChecking"
Option Explicit

'*****************************************************************************
'                  
'                 MS AGENT 2.0   
'
'        (,  TTS),
'       (,  SR)
'
'   :
'     If Not AgentIsInstalled Then Exit Sub
'*****************************************************************************

Private oAgent
Private oChar

Public Function AgentIsInstalled() As Boolean    '   -
                                                 '   .
   Const HEADER$ = "   MS Agent 2.0"
   
   Dim bAgent As Boolean: bAgent = False
   Dim bChar  As Boolean: bChar = False
   Dim bTTS   As Boolean: bTTS = False
   Dim bSR    As Boolean: bSR = False

   If fnLoadAgent() Then                         '  
      bAgent = True                              '.
   Else
      AgentIsInstalled = False
      MsgBox "MS Agent 2.0  ", vbCritical, HEADER
      Exit Function
   End If
   If fnLoadChar() Then                          '  
      bChar = True                               '-.
   Else
      AgentIsInstalled = False
      MsgBox "    ", vbCritical, HEADER
      Exit Function
   End If
   If fnLoadTTS() Then                           '  
      bTTS = True                                'TextToSpeech ()
   Else
      AgentIsInstalled = False
      MsgBox "  (TTS)  ", vbCritical, HEADER
      Exit Function
   End If
'   If fnLoadSR() Then                            '  
      bSR = True                                 ' . 
'   Else
'      AgentIsInstalled = False
'      MsgBox "   (SR)  ", vbCritical, HEADER
'      Exit Function
'   End If
   
   AgentIsInstalled = bAgent * bChar * bTTS * bSR
   
   Set oChar = Nothing
   oAgent.Characters.Unload "Default"
   Set oAgent = Nothing
End Function

Private Function fnLoadAgent() As Boolean
   On Error Resume Next
   Set oAgent = CreateObject("Agent.Control.2")
   If IsObject(oAgent) Then
      fnLoadAgent = True
   Else
      fnLoadAgent = False
      Set oAgent = Nothing
   End If
End Function

Private Function fnLoadChar() As Boolean
   On Error Resume Next
   oAgent.Connected = True
   oAgent.Characters.Load ("Default")
   Set oChar = oAgent.Characters("Default")
   If Err = 0 Then
      fnLoadChar = True
   Else
      fnLoadChar = False
      Set oChar = Nothing
   End If
End Function

Private Function fnLoadTTS() As Boolean
   On Error Resume Next
   Dim sTTS$
   sTTS = oChar.TTSModeID
   fnLoadTTS = (sTTS <> "")
End Function

Private Function fnLoadSR() As Boolean
   On Error Resume Next
   Dim sSR$
   oChar.LanguageID = &H409
   sSR = oChar.SRModeID
   fnLoadSR = (sSR <> "")
End Function
